#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>
#include <ArduinoJson.h>

// Замените на свои сетевые данные
#define WIFI_SSID "XXXXXXXX"
#define WIFI_PASSWORD "XXXXXXXXXXX"

// Инициализация Telegram бота
#define BOT_TOKEN "XXXXXXXXXX:XXXXXXXXXXXXXXXXXXXXXX" // Ваш Токен
#define CHAT_ID "XXXXXXXXXXXX"                                      // ID чата

const unsigned long BOT_MTBS = 1000; // среднее время между сообщениями сканирования
unsigned long bot_lasttime;          // когда было сделано последнее сканирование сообщений
X509List cert(TELEGRAM_CERTIFICATE_ROOT);
WiFiClientSecure secured_client;
UniversalTelegramBot bot(BOT_TOKEN, secured_client);

void handleNewMessages(int numNewMessages)
{
  for (int i = 0; i < numNewMessages; i++)
  {
    String chat_id = bot.messages[i].chat_id;
    String text = bot.messages[i].text;

    String from_name = bot.messages[i].from_name;
    if (from_name == "")
      from_name = "Guest";

    if (bot.messages[i].longitude != 0 || bot.messages[i].latitude != 0)
    {
      Serial.print("Долгота: ");
      Serial.println(String(bot.messages[i].longitude, 6));
      Serial.print("Широта: ");
      Serial.println(String(bot.messages[i].latitude, 6));

      String message = "Я здесь.\n";
      message += "Долгота: " + String(bot.messages[i].longitude, 6) + "\n";
      message += "Широта: " + String(bot.messages[i].latitude, 6) + "\n";
      bot.sendMessage(chat_id, message, "Markdown");
    }
    else if (text == "/start")
    {
      String welcome = from_name + ", добро пожаловать в бот Телеграм,\n";
      welcome += "Отправьте свою геолокацию и посмотрите где вы находитесь на карте\n";

      bot.sendMessage(chat_id, welcome, "Markdown");
    }
  }
}

void setup()
{
  Serial.begin(115200);
  Serial.println();

  Serial.print("Соединяемся с Wifi ");
  Serial.print(WIFI_SSID);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
secured_client.setTrustAnchors(&cert);        // Добавить корневой сертификат для api.telegram.org
  while (WiFi.status() != WL_CONNECTED)
  {
    Serial.print(".");
    delay(500);
  }
  Serial.print("\nСвязь с Wifi установлена. Получение IP адреса: ");
  Serial.println(WiFi.localIP());

  Serial.print("Получение времени: ");
  configTime(0, 0, "pool.ntp.org");           // соединяемся с сервером точного времени UTC  NTP
  time_t now = time(nullptr);
  while (now < 24 * 3600)
  {
    Serial.print(".");
    delay(100);
    now = time(nullptr);
  }
  Serial.println(now);
}

void loop()
{
  if (millis() - bot_lasttime > BOT_MTBS)
  {
    int numNewMessages = bot.getUpdates(bot.last_message_received + 1);

    while (numNewMessages)
    {
      Serial.println("ответ получил");
      handleNewMessages(numNewMessages);
      numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    }

    bot_lasttime = millis();
  }
}
